function BindLinkEditor(map, vector) {
	this.vector_layer = vector;
	this.addConnectionMode = true;
	this.connectionStart = undefined;
	this.startConnectionDraw = false;

	this.linkFeature = undefined;
	this.selectedLinkFeature = undefined;


	this.selectedStartPointStyle = new ol.style.Style({
			image : new ol.style.Circle({
				radius : 9,
				fill : new ol.style.Fill({
					color : 'rgba(0, 0, 255, 1)'

				}),
				stroke : new ol.style.Stroke({
					color : 'rgba(255, 0,0 , 1)',
					width : 2
				})
			})
		});

	this.linkBBNDeleteControlStyle = new ol.style.Style({
			image : new ol.style.Circle({
				radius : 7,
				fill : new ol.style.Fill({
					color : 'rgba(0, 0, 255, 1)'
				}),
				stroke : new ol.style.Stroke({
					color : 'rgba(255, 0,0 , 1)',
					width : 2
				})
			})
		});

	this.defaultPointStyle = new ol.style.Style({
			image : new ol.style.Circle({
				radius : 9,
				fill : new ol.style.Fill({
					color : 'rgba(0, 0, 255, 1)'
				}),
				stroke : new ol.style.Stroke({
					color : 'rgba(0, 0, 255 , 1)',
					width : 2
				})
			})
		});
	this.navNodeStyle = new ol.style.Style({
		image : new ol.style.Circle({
			radius : 9,
			fill : new ol.style.Fill({
				color : 'rgba(0, 0, 255, 1)'
			}),
			stroke : new ol.style.Stroke({
				color : 'rgba(0, 0, 255, 1)',
				width : 2
			})
		})
	});

	this.navNodeBBLPointStyle = new ol.style.Style({
		image : new ol.style.Circle({
			radius : 9,
			fill : new ol.style.Fill({
				color : 'rgba(255, 255, 255, 1)'
			}),
			stroke : new ol.style.Stroke({
				color : 'rgba(0, 255, 0 , 1)',
				width : 2
			})
		})
	});
	this.connectionLinkStyle = new ol.style.Style({
			stroke : new ol.style.Stroke({
				color : 'rgba(255, 0, 0, 1)',
				width : 4
			})
		});

	this.selectedConnectionLinkStyle = new ol.style.Style({
			stroke : new ol.style.Stroke({
				color : 'rgba(255, 0, 0, 1)',
				width : 7
			})

		});

	this.linkConnectionPointStyle = new ol.style.Style({
			image : new ol.style.Circle({
				radius : 9,
				fill : new ol.style.Fill({
					color : 'rgba(255, 255, 255, 1)'
				}),
				stroke : new ol.style.Stroke({
					color : 'rgba(255, 0,0 , 1)',
					width : 2
				})
			})
		});

	this.linkConnectionPointStyleDefault = new ol.style.Style({
			image : new ol.style.Circle({
				radius : 7,
				fill : new ol.style.Fill({
					color : 'rgba(255, 255, 255, 1)'
				}),
				stroke : new ol.style.Stroke({
					color : 'rgba(255, 0,0 , 1)',
					width : 2
				})
			})
		});

	this.registerCreateLinkEvents = function () {
		this.click = map.on('click', this.onClick);
		this.dblclick = map.on('dblclick', this.onDblClick);
		this.pointmove = map.on('pointermove', this.onPointerMove);
		//console.log("registerCreateLinkEvents");
	}

	this.unregisterCreateLinkEvents = function () {
		ol.Observable.unByKey(this.click);
		ol.Observable.unByKey(this.dblclick);
		ol.Observable.unByKey(this.pointmove);
		this.clearConnection();
		this.deselectLink();
	}



	this.onPointerMove = function (evt) {
		//console.log("this.onPointerMove");
		if (bindLinkEditor.connectionStart && bindLinkEditor.startConnectionDraw && bindLinkEditor.linkFeature) {
			//console.log(evt.coordinate);
			var geometry = bindLinkEditor.linkFeature.getGeometry();
			var linkCoord = geometry.getCoordinates();
			//console.log(linkCoord);
			linkCoord[1] = [evt.coordinate[0] - 10, evt.coordinate[1] + 5];
			geometry.setCoordinates(linkCoord);

		} else {
			//	console.log("onPointerMove else");
			// if (this.selectedFeatureForModify){
			////console.log("onPointerMove this.updatePointOnModifyEnd");
			//	  this.updatePointOnModifyEnd(selectedFeatureForModify);
			// }


		}

	}

	this.onClick = function (evt) {
		var selectedFeature = bindLinkEditor.getSelectedStartFeature(evt);
		//console.log("selectedStartFeature: " + selectedFeature.get("type"));
		if (selectedFeature && selectedFeature.get("type") == "link-bbn-delete-control") {
			bindLinkEditor.deleteLink(bindLinkEditor.selectedLinkFeature, evt);
			return;
		} else {
			bindLinkEditor.deselectLink();
		}

		if (bindLinkEditor.addConnectionMode && selectedFeature) {
			if (!bindLinkEditor.connectionStart) {
				var type = 'not-selected';
				if (selectedFeature)
					type = selectedFeature.get("type");
				//console.log("selectedStartFeature: " + type);
				if (bindLinkEditor.isNavNode(selectedFeature) || bindLinkEditor.isNavNodeBBL(selectedFeature)) {
					bindLinkEditor.selectStartPointAndStartConnection(selectedFeature, evt.coordinate);

				} else if (bindLinkEditor.isNavLink(selectedFeature)) {
					bindLinkEditor.selectStartLinkPointAndStartConnection(selectedFeature, evt.coordinate);

				} else if (bindLinkEditor.isLinkBBN(selectedFeature)) {
					bindLinkEditor.selectLink(selectedFeature, evt);

				}
			} else {
				var selectedDestFeature = bindLinkEditor.getSelectedDestFeature(evt);
				//console.log("selectedDestFeature: " + selectedDestFeature.get("type"));
				if (bindLinkEditor.isPoint(selectedDestFeature)) {
					bindLinkEditor.createConnectionToPoint(selectedDestFeature);
				}
				if (bindLinkEditor.isPolygon(selectedDestFeature)) {
					bindLinkEditor.createConnectionToPolygon(selectedDestFeature);
				} else {
					bindLinkEditor.clearConnection();
				}

			}

		}

	}

	this.getSelectedStartFeature = function (evt) {
		var selectedFeature;
		var feature = map.forEachFeatureAtPixel(evt.pixel,
				function (feature) {
				if (!selectedFeature) {
					selectedFeature = feature;
				} else {
					if (this.isNavNode(feature) || this.isNavNodeBBL(feature)) {
						selectedFeature = feature;

					}
				}
				return feature;
			});

		return selectedFeature;
	}

	this.onDblClick = function (evt) {
		//console.log("onDblClick");

		if (bindLinkEditor.addConnectionMode && bindLinkEditor.connectionStart) {
			bindLinkEditor.clearConnection();
		}

		var selectedFeature = bindLinkEditor.getSelectedStartFeature(evt);
		//console.log("selectedFeature " + selectedFeature.get('type'));
		if (bindLinkEditor.isNavLinkConnectNode(selectedFeature)) {
			//console.log("selectedFeature ajust" );
			bindLinkEditor.adjustNavLinkConnectModeToClosestPoint(selectedFeature)
		}

	}

	this.adjustNavLinkConnectModeToClosestPoint = function (connectNode) {
	//	console.log("ajusting");
		var hostLink = connectNode['hostLink'];
		var connectLink = connectNode['connectLink'];
		var startFeature = connectLink['startFeature'];

		var startPointCoord;
		if (this.isPoint(startFeature)) {
			startPointCoord = startFeature.getGeometry().getCoordinates()
		} else if (this.isPolygon(startFeature)) {
			startPointCoord = startFeature.getGeometry().getInteriorPoint().getCoordinates();

		}

		var closest = hostLink.getGeometry().getClosestPoint(startPointCoord);
		connectNode.getGeometry().setCoordinates(closest);
		var geometry = connectLink.getGeometry();
		var linkCoord = geometry.getCoordinates();
		linkCoord[0] = startPointCoord;
		linkCoord[1] = connectNode.getGeometry().getCoordinates();
		geometry.setCoordinates(linkCoord);

	}

	this.selectStartLinkPointAndStartConnection = function (link, coordinate) {

		//console.log('selectStartLinkPointAndStartConnection');
		var linkConnectionFeature = this.createLinkConnectionFeature(link, coordinate);
		this.vector_layer.getSource().addFeature(linkConnectionFeature);
		this.connectionStart = linkConnectionFeature;
		this.startConnectionDraw = true;
		this.linkFeature = this.createLinkFeature(this.connectionStart, coordinate);
		//console.log("this.linkFeature= " + this.linkFeature);
		linkConnectionFeature['hostLink'] = link;
		linkConnectionFeature['connectLink'] = this.linkFeature;
		this.vector_layer.getSource().addFeature(this.linkFeature);

		//	console.log("this.linkFeature= " + this.linkFeature);
	}

	this.createLinkConnectionFeature = function (link, coordinate) {
		var point = new ol.geom.Point(coordinate);
		var nodeFeature =
			new ol.Feature({
				type : 'connect-node-bbl',
				geometry : point,
				name : 'node'
			});
		nodeFeature.setId(uid('BN'));
		nodeFeature.setStyle(this.linkConnectionPointStyle);
		return nodeFeature;
	}

	this.selectLink = function (selectedLink, evt) {
		this.deselectLink();
		this.selectedLinkFeature = selectedLink;
		this.selectedLinkFeature.setStyle(this.selectedConnectionLinkStyle);
		var ext = this.selectedLinkFeature.getGeometry().getExtent();
		var coord = ol.extent.getCenter(ext);
		if(!this.linkDeleteControl)
		this.linkDeleteControl= this.createLinkBBNDeleteControlFeature();	
		this.linkDeleteControl.getGeometry().setCoordinates(coord);
		this.vector_layer.getSource().addFeature(this.linkDeleteControl);
	}

	this.deselectLink = function () {
		if (this.selectedLinkFeature) {
			this.selectedLinkFeature.setStyle(this.connectionLinkStyle);
			this.selectedLinkFeature = null;
			this.vector_layer.getSource().removeFeature(this.linkDeleteControl);
		}

	}

	this.createLinkBBNDeleteControlFeature = function () {
		var circle = new ol.geom.Point([0, 0]);
		var nodeFeature =
			new ol.Feature({
				id : 'nodeFeature',
				type : 'link-bbn-delete-control',
				geometry : circle,
				name : 'node'
			});

		nodeFeature.setStyle(this.linkBBNDeleteControlStyle);
		return nodeFeature;
	}

	this.deleteLink = function (deleteControl, evt) {
		//console.log("delete link ");
		if (this.selectedLinkFeature) {
			var startFeature = this.selectedLinkFeature['startFeature'];
			var endFeature = this.selectedLinkFeature['endFeature'];
			////console.log("this.clearLinkOnDelete:end Feature " + feature['links-bbn']);
			this.clearLinkOnDelete(startFeature, this.selectedLinkFeature);
			if (this.isNavLinkConnectNode(endFeature))
				this.vector_layer.getSource().removeFeature(endFeature);
			this.vector_layer.getSource().removeFeature(this.selectedLinkFeature);
			this.vector_layer.getSource().removeFeature(this.linkDeleteControl);
		}

		this.selectedLinkFeature = null;
	}

	this.clearLinkOnDelete = function (feature, link) {
		//	console.log("this.clearLinkOnDelete");
		//console.log("this.clearLinkOnDelete: " + feature['links-bbn']);
		if (feature && feature['links-bbn']) {
			var index = feature['links-bbn'].indexOf(link);
			if (index != -1) {
				feature['links-bbn'].splice(index, 1);
				//console.log("this.clearLinkOnDelete: " + index);
				//console.log("remove from polygon "+ polygon['linkPoints'].length);
			}
		}
	}

	this.getSelectedDestFeature = function (evt) {
		var selectedFeature;
		var feature = map.forEachFeatureAtPixel(evt.pixel,
				function (feature) {
				////console.log(feature.get("type"));
				if (!selectedFeature) {
					selectedFeature = feature;
				} else {
					if (feature.get("gType") == "Point") {
						selectedFeature = feature;

					} else if (feature.get("gType") == "Polygon") {
						console.log("Polygon");

						selectedFeature = feature;

					}
				}
				return feature;
			});

		return selectedFeature;
	}

	this.selectStartPointAndStartConnection = function (feature, coordinate) {

		//console.log("selectStartPointAndStartConnection");
        if(!feature)return;
		feature.setStyle(this.selectedStartPointStyle);
		this.connectionStart = feature;
		this.startConnectionDraw = true;
		this.linkFeature = this.createLinkFeature(feature, coordinate);
		//this.linkFeature['startPoint'] =start;
		this.vector_layer.getSource().addFeature(this.linkFeature);
	}

	this.createConnectionToPoint = function (connectionEnd) {
	if(!this.linkFeature) return;
		// check if link exists
		if (connectionEnd['links-bbn']) {
			for (var n = 0; n < connectionEnd['links-bbn'].length; n++) {
				link = connectionEnd['links-bbn'][n];

				if (link['startFeature'] == connectionEnd && link['endFeature'] == this.connectionStart)
					return;

			}
		}

		var geometry = this.linkFeature.getGeometry();
		var linkCoord = geometry.getCoordinates();
		//console.log(linkCoord);
		linkCoord[0] = connectionEnd.getGeometry().getCoordinates();
		linkCoord[1] = this.connectionStart.getGeometry().getCoordinates();
		geometry.setCoordinates(linkCoord);

		if (this.isNavNode(this.connectionStart))
			this.connectionStart.setStyle(this.defaultPointStyle);
		if (this.isNavNodeBBL(this.connectionStart))
			this.connectionStart.setStyle(this.navNodeBBLPointStyle);

		if (this.isNavLinkConnectNode(this.connectionStart))
			this.connectionStart.setStyle(this.linkConnectionPointStyleDefault);

		this.linkFeature['endFeature'] = this.connectionStart;
		this.linkFeature['startFeature'] = connectionEnd;
		if (!connectionEnd["links-bbn"])
			connectionEnd["links-bbn"] = [];
		connectionEnd['links-bbn'].push(this.linkFeature);

		//cleanup
		this.connectionStart = undefined;
		this.startConnectionDraw = false;
		this.linkFeature = undefined;
	}

	this.createConnectionToPolygon = function (connectionEnd) {

		if (connectionEnd['links-bbn']) {
			for (var n = 0; n < connectionEnd['links-bbn'].length; n++) {
				link = connectionEnd['links-bbn'][n];

				if (link['startFeature'] == connectionEnd && link['endFeature'] == this.connectionStart)
					return;

			}
		}

		var connectionEndPoint = connectionEnd.getGeometry().getInteriorPoint();

		var geometry = this.linkFeature.getGeometry();
		var linkCoord = geometry.getCoordinates();
		//console.log(linkCoord);
		linkCoord[0] = connectionEndPoint.getCoordinates();
		linkCoord[1] = this.connectionStart.getGeometry().getCoordinates();
		geometry.setCoordinates(linkCoord);
		if (this.isNavNode(this.connectionStart))
			this.connectionStart.setStyle(this.defaultPointStyle);
		if (this.isNavLinkConnectNode(this.connectionStart))
			this.connectionStart.setStyle(this.linkConnectionPointStyleDefault);

		this.linkFeature['endFeature'] = this.connectionStart;
		this.linkFeature['startFeature'] = connectionEnd;
		if (!connectionEnd["links-bbn"])
			connectionEnd["links-bbn"] = [];
		connectionEnd['links-bbn'].push(this.linkFeature);

		//cleanup
		this.connectionStart = undefined;
		this.startConnectionDraw = false;
		this.linkFeature = undefined;
	}

	this.clearConnection = function () {

		if (this.connectionStart) {

			if (this.connectionStart.get("type") == "nav-node") {
				this.clearConnectionToBBN();
			} else if (this.connectionStart.get("type") == "connect-node-bbl") {
				this.clearConnectionToConnectNodeBBL()
			}
		}
	}

	this.clearConnectionToBBN = function () {
		this.connectionStart.setStyle(this.defaultPointStyle);
		this.connectionStart = undefined;
		this.startConnectionDraw = false;
		if (this.linkFeature)
			this.vector_layer.getSource().removeFeature(this.linkFeature);
		this.linkFeature = undefined;
	}

	this.clearConnectionToConnectNodeBBL = function () {
		if (this.linkFeature)
			this.vector_layer.getSource().removeFeature(this.linkFeature);
		this.vector_layer.getSource().removeFeature(this.connectionStart);
		this.startConnectionDraw = false;
		this.connectionStart = undefined;
		this.linkFeature = undefined;

	}

	this.createLinkFeature = function (startFeature, pointerCoord) {
		//console.log(startFeature.getGeometry().getType());
		var start = startFeature.getGeometry().getCoordinates();
		this.linkFeature =
			new ol.Feature({
				type : 'link-bbn',
				geometry : new ol.geom.LineString([start, pointerCoord]),
				name : 'link'
			});
		//nodeFeature.setId(id);
		var id = uid('BL');
		this.linkFeature.setId(id);
		this.linkFeature.setStyle(this.connectionLinkStyle);
		//nodeFeature.setId(id);
		//console.log(" created link " + this.linkFeature);
		return this.linkFeature;

	}

	this.updateLinkPositionOnModifyEnd = function (evt) {
		////console.log("this.updateLinkPositionOnModifyEnd");
		var features = evt.features.getArray();
		if (features) {
			for (var i = 0; i < features.length; i++) {
				//console.log("features[i])= " + features[i].getId());

				// if(this.vector_layer.features && this.vector_layer.features.indexOf(features[i])>-1){

				if (this.isPoint(features[i])) {
					//console.log("this.updatePointOnModifyEnd");
					this.updatePointOnModifyEnd(features[i]);

				} else if (this.isPolygon(features[i])) {
					//console.log("this.updatePolygonOnModifyEnd");
					this.updatePolygonOnModifyEnd(features[i]);

					// }
				}
			}
		}

	}

	this.updatePointOnModifyEnd = function (mainPointFeature) {

		if (mainPointFeature['links-bbn']) {
			//console.log('updateLinksPosition '+ mainPointFeature['links']);
			for (var n = 0; n < mainPointFeature['links-bbn'].length; n++) {
				var link = mainPointFeature['links-bbn'][n];
				coord = link.getGeometry().getCoordinates();
				coord[0] = mainPointFeature.getGeometry().getCoordinates();
				link.getGeometry().setCoordinates(coord);

			}

		}

	}

	this.updatePolygonOnModifyEnd = function (mainPointFeature) {

		if (mainPointFeature['links-bbn']) {
			//console.log('updateLinksPosition '+ mainPointFeature['links']);
			for (var n = 0; n < mainPointFeature['links-bbn'].length; n++) {
				var link = mainPointFeature['links-bbn'][n];
				coord = link.getGeometry().getCoordinates();
				coord[0] = mainPointFeature.getGeometry().getInteriorPoint().getCoordinates();
				link.getGeometry().setCoordinates(coord);

			}

		}
	}

	this.updateDeleteControlPosition = function (link) {
		var ext = link.getGeometry().getExtent();
		var coord = ol.extent.getCenter(ext);
		var deleteControl = link['deleteControl']
			deleteControl.getGeometry().setCoordinates(coord);
	}

	this.updateLinksOnDelete = function (mainPointFeature) {
		if (mainPointFeature['links-bbn']) {
			//console.log('updateLinksPosition '+ mainPointFeature['links']);
			for (var n = 0; n < mainPointFeature['links-bbn'].length; n++) {
				var link = mainPointFeature['links-bbn'][n];
				this.vector_layer.getSource().removeFeature(link);
				var endFeature = link['endFeature'];
				if (this.isNavLinkConnectNode(endFeature))
					this.vector_layer.getSource()
					.removeFeature(endFeature);
			}
		}

	}


	this.isNavNode = function (feature) {
		return feature && (feature.get("type") == "nav-node");
	}

	this.isNavNodeBBL = function (feature) {
		return feature && (feature.get("type") == "nav-node-bbl");
	}

	this.isNavLink = function (feature) {
		return feature && feature.get("type") == "nav-link";
	}
	this.isLinkBBN = function (feature) {
		return feature && feature.get("type") == "link-bbn";
	}
	this.isNavLinkConnectNode = function (feature) {
		return feature && feature.get("type") == "connect-node-bbl";
	}

	this.isPoint = function (feature) {
		return feature && feature.get("gType") == "Point";
	}
	this.isPolygon = function (feature) {
		return feature && feature.get("gType") == "Polygon";
	}

	
}