function BindLinkEditor(map, vector) {
	this.map = map;
	this.vector_layer = vector;
	this.bindLinkEditor = this;
	


this.addConnectionMode = true;
this.startConnectionDraw = false;



this.polygonStyle  = new ol.style.Style({
		stroke : new ol.style.Stroke({
			color : 'rgba(0, 0, 255, 1)',
			width : 1

		}),
		fill : new ol.style.Fill({
			color : 'rgba(0, 0, 255, 0.2)'
		})
	});

this.selectedStartPointStyle = new ol.style.Style({
		image : new ol.style.Circle({
			radius : 9,
			fill : new ol.style.Fill({
				color : 'blue'
			}),
			stroke : new ol.style.Stroke({
				color : 'red',
				width : 2
			})
		})
	});

this.linkBBNDeleteControlStyle = new ol.style.Style({
		image : new ol.style.Circle({
			radius : 7,
			fill : new ol.style.Fill({
				color : 'rgba(0, 0, 0, 1)'
			}),
			stroke : new ol.style.Stroke({
				color : 'rgba(255, 0,0 , 1)',
				width : 2
			})
		})
	});

this.defaultPointStyle = new ol.style.Style({
		image : new ol.style.Circle({
			radius : 9,
			fill : new ol.style.Fill({
				color : 'blue'
			}),
			stroke : new ol.style.Stroke({
				color : 'rgba(0, 0, 255, 1)',
				width : 2
			})
		})
	});

this.connectionLinkStyle = new ol.style.Style({
		stroke : new ol.style.Stroke({
			color : 'rgba(0, 0, 255, 1)',
			width : 4
		})
	});

this.selectedConnectionLinkStyle = new ol.style.Style({
		stroke : new ol.style.Stroke({
			color : 'rgba(0, 0, 255, 1)',
			width : 7
		})

	});

this.linkConnectionPointStyle = new ol.style.Style({
		image : new ol.style.Circle({
			radius : 9,
			fill : new ol.style.Fill({
				color : 'rgba(255, 255, 255, 1)'
			}),
			stroke : new ol.style.Stroke({
				color : 'rgba(255, 0,0 , 1)',
				width : 2
			})
		})
	});

this.linkConnectionPointStyleDefault = new ol.style.Style({
		image : new ol.style.Circle({
			radius : 9,
			fill : new ol.style.Fill({
				color : 'rgba(255, 255, 255, 1)'
			}),
			stroke : new ol.style.Stroke({
				color : 'rgba(0, 0,255 , 1)',
				width : 2
			})
		})
	});

this.registerCreateLinkEvents = function () {
	this.click = map.on('click', this.onClick);
	this.dblclick = map.on('dblclick', this.onDblClick);
	this.pointmove = map.on('pointermove', this.onPointerMove);
	//console.log("registerCreateLinkEvents");
}

this.unregisterCreateLinkEvents = function () {
	ol.Observable.unByKey(this.click);
	ol.Observable.unByKey(this.dblclick);
	ol.Observable.unByKey(this.pointmove);
	this.clearConnection();
	this.deselectLink();
}


this.onPointerMove = function (evt) {
	//console.log("this.onPointerMove");

	if (bindLinkEditor.connectionStart && bindLinkEditor.startConnectionDraw && bindLinkEditor.linkFeature) {
		//console.log(evt.coordinate);
		var geometry = bindLinkEditor.linkFeature.getGeometry();
		var linkCoord = geometry.getCoordinates();
		//console.log(linkCoord);
		linkCoord[1] = [evt.coordinate[0] - 10, evt.coordinate[1] + 5];
		geometry.setCoordinates(linkCoord);

	} else {
		//	console.log("onPointerMove else");
		// if (this.selectedFeatureForModify){
		////console.log("onPointerMove this.updatePointOnModifyEnd");
		//	  this.updatePointOnModifyEnd(selectedFeatureForModify);
		// }


	}

}

this.onClick = function (evt) {
	var selectedFeature = bindLinkEditor.getSelectedStartFeature(evt);
	if (selectedFeature && selectedFeature.get("type") == "link-delete-control" && bindLinkEditor.selectedLinkFeature) {
		bindLinkEditor.deleteLink(bindLinkEditor.selectedLinkFeature, evt);
		return;
	} else {
		//this.deselectLink();
	}

	if (bindLinkEditor.addConnectionMode && selectedFeature) {
		if (!bindLinkEditor.connectionStart) {
			var type = 'not-selected';
			if (selectedFeature)
				type = selectedFeature.get("type");
			console.log("selectedStartFeature: " + type);
			if (bindLinkEditor.isNavNode(selectedFeature)) {
				bindLinkEditor.selectStartPointAndStartConnection(selectedFeature, evt.coordinate);

			} else if (bindLinkEditor.isNavLink(selectedFeature)) {
				bindLinkEditor.selectStartLinkPointAndStartConnection(selectedFeature, evt.coordinate);
				//this.selectLink(selectedFeature, evt);
			} 
		} else {
			var selectedDestFeature = bindLinkEditor.getSelectedDestFeature(evt);
			//console.log("selectedDestFeature: " + selectedDestFeature.get("type"));
			if ( bindLinkEditor.isNavNode(selectedDestFeature)) {
				bindLinkEditor.createConnectionToPoint(selectedDestFeature);
			}
			if ( bindLinkEditor.isNavLink(selectedDestFeature)) {
				bindLinkEditor.createConnectionToLink(selectedDestFeature,evt);
			}
			if (bindLinkEditor.isPolygon(selectedDestFeature)) {
				bindLinkEditor.createConnectionToPolygon(selectedDestFeature);
			} else {
				bindLinkEditor.clearConnection();
			}

		}

	}

}

this.getSelectedStartFeature = function (evt) {
	var selectedFeature = this.forcedSF;
		if(selectedFeature) return selectedFeature
	var feature = map.forEachFeatureAtPixel(evt.pixel,
			function (feature) {
			if (!selectedFeature) {
				selectedFeature = feature;
			} else {
				if (this.isNavNode(feature) || this.isNavLinkConnectNode(feature)) {
					selectedFeature = feature;

				}
			}
			return feature;
		});

	return selectedFeature;
}

this.onDblClick = function (evt) {
	console.log("onDblClick");
	evt.preventDefault();
	
	if (bindLinkEditor.addConnectionMode && bindLinkEditor.connectionStart) {
		bindLinkEditor.clearConnection();
	}

	var selectedFeature = bindLinkEditor.getSelectedStartFeature(evt);

	if (bindLinkEditor.isNavLinkConnectNode(selectedFeature)) {

		bindLinkEditor.adjustNavLinkConnectModeToClosestPoint(selectedFeature)
	}
	
	

}

this.adjustNavLinkConnectModeToClosestPoint = function (connectNode) {

	var hostLink = connectNode['hostLink'];
	var connectLink = connectNode['connectLink'];
	var startPoint = connectLink['startPoint'];
    var endPoint = connectLink['endPoint'];
	var destFeature;
	
	if(connectNode===startPoint) 
		destFeature = endPoint
	else destFeature = startPoint
	
	var startPointCoord;
	startPointCoord = destFeature.getGeometry().getCoordinates()

	var closest = hostLink.getGeometry().getClosestPoint(startPointCoord);
	connectNode.getGeometry().setCoordinates(closest);
	var geometry = connectLink.getGeometry();
	var linkCoord = geometry.getCoordinates();
	linkCoord[0] = startPointCoord;
	linkCoord[1] = connectNode.getGeometry().getCoordinates();
	geometry.setCoordinates(linkCoord);
	this.updateNavNodesBBN(hostLink);

}

this.selectStartLinkPointAndStartConnection = function (link, coordinate) {

	//console.log(coord);
	var linkConnectionFeature = this.createLinkConnectionFeature(link, coordinate);
	this.vector_layer.getSource().addFeature(linkConnectionFeature);
	this.connectionStart = linkConnectionFeature;
	this.startConnectionDraw = true;
	this.linkFeature = this.createLinkFeature(this.connectionStart,coordinate);
	//console.log("this.linkFeature" + this.linkFeature);
	linkConnectionFeature['hostLink'] = link;
	linkConnectionFeature['connectLink'] = this.linkFeature;
	this.vector_layer.getSource().addFeature(this.linkFeature);
		//console.log("this.vector_layer" + this.vector_layer);
	this.linkFeature
}

this.createLinkConnectionFeature = function (link, coordinate) {
	var	closestPoint = link.getGeometry().getClosestPoint(coordinate);
	var point = new ol.geom.Point(closestPoint);

	var nodeFeature =
		new ol.Feature({
			type : 'nav-node-bbl',
			geometry : point,
			name : 'node'
		});
    nodeFeature.setId(uid("N"));
	nodeFeature.setStyle(this.linkConnectionPointStyle);
	return nodeFeature;
}



this.selectLink = function (selectedLink, evt) {
	//this.deselectLink();
	this.selectedLinkFeature = selectedLink;
	this.selectedLinkFeature.setStyle(this.selectedConnectionLinkStyle);
	var ext = this.selectedLinkFeature.getGeometry().getExtent();
	var coord = ol.extent.getCenter(ext);
	if(!this.linkDeleteControl)
	this.linkDeleteControl = this.createLinkBBNDeleteControlFeature();
	this.linkDeleteControl.getGeometry().setCoordinates(coord);
	this.vector_layer.getSource().addFeature(this.linkDeleteControl);
}

this.deselectLink = function () {
	if (this.selectedLinkFeature) {
		this.selectedLinkFeature.setStyle(this.connectionLinkStyle);
		this.selectedLinkFeature = null;
		this.vector_layer.getSource().removeFeature(this.linkDeleteControl);
	}

}

this.createLinkBBNDeleteControlFeature = function () {
	var circle = new ol.geom.Point([0, 0]);
	var nodeFeature =
		new ol.Feature({
			id : 'nodeFeature',
			type : 'link-delete-control',
			geometry : circle,
			name : 'node'
		});

	nodeFeature.setStyle(this.linkBBNDeleteControlStyle);
	return nodeFeature;
}



this.getSelectedDestFeature = function (evt) {
	var selectedFeature;
	var feature = map.forEachFeatureAtPixel(evt.pixel,
			function (feature) {
			////console.log(feature.get("type"));
			if (!selectedFeature) {
				selectedFeature = feature;
			} else {
				if (this.isNavNode(selectedFeature)) {
					selectedFeature = feature;

				} else if (this.isNavPolygon(selectedFeature)) {
					console.log("Polygon");

					selectedFeature = feature;

				}
			}
			return feature;
		});

	return selectedFeature;
}

this.selectStartPointAndStartConnection = function (feature, coordinate) {

	console.log("selectStartPointAndStartConnection: " );

	feature.setStyle(this.selectedStartPointStyle);
	this.connectionStart = feature;
	this.startConnectionDraw = true;
	this.linkFeature = this.createLinkFeature(feature, coordinate);
	this.vector_layer.getSource().addFeature(this.linkFeature);
}

this.createConnectionToPoint = function (connectionEnd) {
	
	if ( this.connectionStart  === connectionEnd){
			console.log("connection to self not allowed");
			this.clearConnection();
				return;
	}
			
		// check if link exists
	if (this.connectionStart['links']) {
		for (var n = 0; n < this.connectionStart['links'].length; n++) {
			var link = this.connectionStart['links'][n];
			coord = link.getGeometry().getCoordinates();

			if (link['startPoint'] == this.connectionStart && link['endPoint'] == connectionEnd){
				console.log("connection exists");
				return;
			}
				

			if (link['endPoint'] == this.connectionStart && link['startPoint'] == connectionEnd){
				
				console.log("connection exists");
				return;
			}
			

		}
	}

	
 	
	var connectionStart=this.connectionStart;
	var linkFeature=this.linkFeature;
	var geometry = this.linkFeature.getGeometry();
	var linkCoord = geometry.getCoordinates();
	
	linkCoord[1] = connectionEnd.getGeometry().getCoordinates();
	geometry.setCoordinates(linkCoord);
	connectionStart.setStyle(this.defaultPointStyle);

	linkFeature['startPoint'] = connectionStart;
	if (!connectionStart["links"])
		connectionStart["links"] = [];
	connectionStart['links'].push(linkFeature);

	linkFeature['endPoint'] = connectionEnd;
	if (!connectionEnd["links"])
		connectionEnd["links"] = [];
	connectionEnd['links'].push(linkFeature);

	if (this.isNavNode(this.connectionStart))
		this.connectionStart.setStyle(this.defaultPointStyle);
	
	
	if (this.isNavLinkConnectNode(this.connectionStart)){
		this.connectionStart.setStyle(this.linkConnectionPointStyleDefault);
		var hostLink=connectionStart['hostLink'];
		
	if(!hostLink["navNodesBBL"])
	   hostLink["navNodesBBL"] =[];
       hostLink["navNodesBBL"].push(this.connectionStart);
	   
	 //  console.log("navNodesBBL " + hostLink["navNodesBBL"].length);
	}

	this.linkFeature['startPoint'] = this.connectionStart;
	// create delete control
	
	
	//cleanup
	this.connectionStart = undefined;
	this.startConnectionDraw = false;
	this.linkFeature = undefined;
}

this.createConnectionToLink = function (connectionEndLink,evt) {
	
	//console.log(coord);
	var linkConnectionFeature = this.createLinkConnectionFeature(connectionEndLink, evt.coordinate);
	this.vector_layer.getSource().addFeature(linkConnectionFeature);
	
	this.vector_layer.getSource().addFeature(this.linkFeature);
	
	
	linkConnectionFeature['hostLink'] = connectionEndLink;
	linkConnectionFeature['connectLink'] = this.linkFeature;
	this.vector_layer.getSource().addFeature(this.linkFeature);
	
	var connectionEnd = linkConnectionFeature;
	
	if ( this.connectionStart  === connectionEnd){
			console.log("connection to self not allowed");
			this.clearConnection();
				return;
	}
			
		// check if link exists
	if (this.connectionStart['links']) {
		for (var n = 0; n < this.connectionStart['links'].length; n++) {
			var link = this.connectionStart['links'][n];
			coord = link.getGeometry().getCoordinates();

			if (link['startPoint'] == this.connectionStart && link['endPoint'] == connectionEnd){
				console.log("connection exists");
				return;
			}
				

			if (link['endPoint'] == this.connectionStart && link['startPoint'] == connectionEnd){
				
				console.log("connection exists");
				return;
			}
			

		}
	}

	
 	
	var connectionStart=this.connectionStart;
	var linkFeature=this.linkFeature;
	var geometry = this.linkFeature.getGeometry();
	var linkCoord = geometry.getCoordinates();
	
	linkCoord[1] = connectionEnd.getGeometry().getCoordinates();
	geometry.setCoordinates(linkCoord);
	connectionStart.setStyle(this.defaultPointStyle);

	linkFeature['startPoint'] = connectionStart;
	if (!connectionStart["links"])
		connectionStart["links"] = [];
	connectionStart['links'].push(linkFeature);

	linkFeature['endPoint'] = connectionEnd;
	if (!connectionEnd["links"])
		connectionEnd["links"] = [];
	connectionEnd['links'].push(linkFeature);

	if (this.isNavNode(this.connectionStart))
		this.connectionStart.setStyle(this.defaultPointStyle);
	
	
	if (this.isNavLinkConnectNode(this.connectionStart)){
		this.connectionStart.setStyle(this.linkConnectionPointStyleDefault);
		var hostLink=connectionStart['hostLink'];
		
	if(!hostLink["navNodesBBL"])
	   hostLink["navNodesBBL"] =[];
       hostLink["navNodesBBL"].push(this.connectionStart);
	   
	   console.log("navNodesBBL " + hostLink["navNodesBBL"].length);
	}
	
	if (this.isNavLinkConnectNode(connectionEnd)){
		connectionEnd.setStyle(this.linkConnectionPointStyleDefault);
		var hostLink=connectionEnd['hostLink'];
		
	if(!hostLink["navNodesBBL"])
	   hostLink["navNodesBBL"] =[];
       hostLink["navNodesBBL"].push(connectionEnd);
	   
	   console.log("navNodesBBL " + hostLink["navNodesBBL"].length);
	}
	
	this.linkFeature['startPoint'] = this.connectionStart;
	// create delete control
	
	
	//cleanup
	this.connectionStart = undefined;
	this.startConnectionDraw = false;
	this.linkFeature = undefined;
}

this.createConnectionToPolygon = function (connectionEnd) {

	if (connectionEnd['links-bbn']) {
		for (var n = 0; n < connectionEnd['links-bbn'].length; n++) {
			link = connectionEnd['links-bbn'][n];

			if (link['startFeature'] == connectionEnd && link['endFeature'] == this.connectionStart)
				return;

		}
	}

	var connectionEndPoint = connectionEnd.getGeometry().getInteriorPoint();

	var geometry = this.linkFeature.getGeometry();
	var linkCoord = geometry.getCoordinates();
	//console.log(linkCoord);
	linkCoord[0] = connectionEndPoint.getCoordinates();
	linkCoord[1] = this.connectionStart.getGeometry().getCoordinates();
	geometry.setCoordinates(linkCoord);
	if (this.isNavNode(this.connectionStart))
		this.connectionStart.setStyle(this.defaultPointStyle);
	if (this.isNavLinkConnectNode(this.connectionStart))
		this.connectionStart.setStyle(this.linkConnectionPointStyleDefault);

	this.linkFeature['endFeature'] = this.connectionStart;
	this.linkFeature['startFeature'] = connectionEnd;
	if (!connectionEnd["links-bbn"])
		connectionEnd["links-bbn"] = [];
	connectionEnd['links-bbn'].push(this.linkFeature);

	//cleanup
	this.connectionStart = undefined;
	this.startConnectionDraw = false;
	this.linkFeature = undefined;
}

this.clearConnection = function () {

	if (this.connectionStart) {

		if (this.connectionStart.get("type") == "nav-node") {
			this.clearConnectionToBBN();
		} else if (this.connectionStart.get("type") == "nav-node-bbl") {
			this.clearConnectionToConnectNodeBBL()
		}
	}
}

this.clearConnectionToBBN = function () {
	this.connectionStart.setStyle(this.defaultPointStyle);
	this.connectionStart = undefined;
	this.startConnectionDraw = false;
	if (this.linkFeature)
		this.vector_layer.getSource().removeFeature(this.linkFeature);
	this.linkFeature = undefined;
}

this.clearConnectionToConnectNodeBBL = function () {
	if (this.linkFeature)
		this.vector_layer.getSource().removeFeature(this.linkFeature);
	this.vector_layer.getSource().removeFeature(this.connectionStart);
	this.startConnectionDraw = false;
	this.connectionStart = undefined;
	this.linkFeature = undefined;

}



this.createLinkFeature = function (startFeature, pointerCoord) {
	//console.log(startFeature.getGeometry().getType());
	var start = startFeature.getGeometry().getCoordinates();
	this.linkFeature =
		new ol.Feature({
			type : 'nav-link',
			geometry : new ol.geom.LineString([start, pointerCoord]),
			name : 'link'
		});
	//nodeFeature.setId(id);
	var id = uid("NL");
	this.linkFeature.setId(id);
	this.linkFeature.setStyle(this.connectionLinkStyle);
	//nodeFeature.setId(id);
	return this.linkFeature;

}


this.removeSelectedFeature = function (selected_feature) {

 if (selected_feature.get("type") == "nav-node" ){
		this.clearPolygonLinkOnDelete(selected_feature);
		this.clearLinkedFeaturesOnDelete(selected_feature);
		this.vector_layer.getSource().removeFeature(selected_feature);
	}
	if (selected_feature.get("type") == "nav-node-polygon") {
		this.clearLinkedFeaturesOnDeletePolygon(selected_feature);
		this.vector_layer.getSource().removeFeature(selected_feature);
	}
	if (selected_feature.get("type") == "nav-link") {
		this.clearLinkedFeaturesOnDeleteLink(selected_feature);

	}
	if (selected_feature.get("type") == "nav-node-bbl") {
		var link = selected_feature['links'][0];
		this.clearLinkedFeaturesOnDeleteLink(link);
		//this.clearLinkedFeaturesOnDelete(selected_feature);
		//this.vector_layer.getSource().removeFeature(selected_feature);
	
	}
	

}



this.clearLinkedFeaturesOnDeleteLink = function (link) {
	//console.log("delete link " + link.getId());
	
	//	console.log("this.clearLinkOnDelete:end Feature " + feature['links-bbn']);

		var startFeature = link['startPoint'];
		//	console.log("startFeature before " + startFeature.get('type') + ': '+ startFeature.getId());
		//	console.log("startFeature['links'] before " + startFeature['links'].length);
			
		var endFeature = link['endPoint'];
		//	console.log("endFeature before " + endFeature.get('type') + ': '+ endFeature.getId());
				console.log("endFeature['links'] before " + endFeature['links'].length);
			
			
		this.removeObjectFromArray(startFeature['links'],link);
		//console.log("startFeature['links'] after " + startFeature['links'].length);
		
		
		this.removeObjectFromArray(endFeature['links'],link);
		//console.log("endFeature['links'] after " + endFeature['links'].length);
		
		this.clearLinkBBLConnectionsOnDelete(link);

        

		this.vector_layer.getSource().removeFeature(link);

		if (this.isNavLinkConnectNode(startFeature)) {
			this.removeObjectFromArray(startFeature.hostLink['navNodesBBL'], startFeature);
			this.vector_layer.getSource().removeFeature(startFeature);
		}

		if (this.isNavLinkConnectNode(endFeature)) {
			this.removeObjectFromArray(endFeature.hostLink['navNodesBBL'], endFeature);
			this.vector_layer.getSource().removeFeature(endFeature);
		}
			
		//this.vector_layer.getSource().removeFeature(this.selectedLinkFeature);
		//this.vector_layer.getSource().removeFeature(this.linkDeleteControl);
	
	//this.selectedLinkFeature = null;
}


this.removeObjectFromArray= function(array,object){
if (array && array.length > 0 ) {
		var index = array.indexOf(object);
		console.log("index "+index);
		if (index != -1) {
			array.splice(index, 1);

		}
	}
return array;
}		
			



// nav delete

this.clearPolygonLinkOnDelete = function (feature) {
	//console.log("clearPolygonLinkOnDelete");
	var polygon = feature['polygon'];
	if (polygon && polygon['linkPoints'].length) {
		var index = polygon['linkPoints'].indexOf(feature);
		if (index != -1) {
			polygon['linkPoints'].splice(index, 1);

		}
	}
}

this.clearLinkedFeaturesOnDelete  = function (feature) {
	console.log("clearLinkedFeaturesOnDelete");

	if (feature['links']) {
	var linkArrayCopy = feature['links'].slice(0,feature['links'].length)
	for (var l in linkArrayCopy) {
			var link = linkArrayCopy[l];
			this.clearLinkedFeaturesOnDeleteLink(link)
			
		}

	} 
}

this.clearLinkBBLConnectionsOnDelete = function(link) {
	  if(link["navNodesBBL"]){
		 for (var n = 0; n < link['navNodesBBL'].length; n++) {
			var connectNavNode = link['navNodesBBL'][n];
			this.clearLinkedFeaturesOnDelete(connectNavNode);
		} 
	  }

}


this.clearLinkedFeaturesOnDeletePolygon  = function (polygon) {
	//onsole.log("clearLinkedFeaturesOnDelete polygon");
	if (polygon['linkPoints']) {
		for (var n = 0; n < polygon['linkPoints'].length; n++) {
			var point = polygon['linkPoints'][n];

			//console.log("clearLinkedFeaturesOnDelete linkedPoint " +point);
			this.clearLinkedFeaturesOnDelete(point);
			this.vector_layer.getSource().removeFeature(point);

		}

	}
}

this.updateFeatureOnModifyEnd  = function (evt) {
var features = evt.features.getArray();
	if (features) {
		for (var i = 0; i < features.length; i++) {
			//console.log("features[i])= " + features[i].getId());

			if (features[i].get("type") == "nav-node") {
				//console.log("updatePointOnModifyEnd");
				this.updatePointOnModifyEnd(features[i]);

			} else if (features[i].get("type") == "nav-node-polygon") {
				//console.log("updatePolygonOnModifyEnd");
				this.updatePolygonOnModifyEnd(features[i]);

			}else if (features[i].get("type") == "nav-node-bbl") {
				//console.log("updatePolygonOnModifyEnd");
				 this.updateNavNodeBBN(features[i]);

			}
		}
	}
}	

this.updatePointOnModifyEnd  = function (mainPointFeature) {

	var polygon = mainPointFeature['polygon'];

	if (polygon) {
		var closestPoint = polygon.getGeometry().getClosestPoint(mainPointFeature.getGeometry().getCoordinates());
		console.log('closestPoint ' + closestPoint);
		if (closestPoint) {
			mainPointFeature.getGeometry().setCoordinates(closestPoint);
			
		}

	}
    this.updateLinksPosition(mainPointFeature);
}


this.updatePolygonOnModifyEnd  = function (polygon) {
	if (polygon['linkPoints']) {
		for (var n = 0; n < polygon['linkPoints'].length; n++) {
			var point = polygon['linkPoints'][n];
			var closestPoint = polygon.getGeometry().getClosestPoint(point.getGeometry().getCoordinates());
			point.getGeometry().setCoordinates(closestPoint);
			this.updateLinksPosition(point);
		}
	}

}

this.updateLinksPosition  = function  (mainPointFeature) {

	if (mainPointFeature['links']) {
		//console.log('updateLinksPosition '+ mainPointFeature['links']);
		for (var n = 0; n < mainPointFeature['links'].length; n++) {
			var link = mainPointFeature['links'][n];
			var coord = link.getGeometry().getCoordinates();

			if (link['startPoint'] == mainPointFeature) {
				var endFeature =link['endPoint'];
				coord[0] = mainPointFeature.getGeometry().getCoordinates();
	            coord[1] = endFeature.getGeometry().getCoordinates();
			} else {
				var startFeature =link['startPoint'];
				coord[0] = startFeature.getGeometry().getCoordinates();
				coord[1] = mainPointFeature.getGeometry().getCoordinates();

			}

			//console.log('updateLinksPosition setCoordinates '+ coord);
			link.getGeometry().setCoordinates(coord);
			
	        this.updateNavNodesBBN(link);

		}
	}

}

this.updateNavNodesBBN = function(link) {
	  if(link["navNodesBBL"]){
		 for (var n = 0; n < link['navNodesBBL'].length; n++) {
			var connectNavNode = link['navNodesBBL'][n];
		      this.updateNavNodeBBN(connectNavNode);
		} 
		  
	  }
	
	
}


this.updateNavNodeBBN = function(connectNavNode) {
			var link =connectNavNode['hostLink'];
	 	   var closestPoint = link.getGeometry().getClosestPoint(connectNavNode.getGeometry().getCoordinates());
			connectNavNode.getGeometry().setCoordinates(closestPoint);
			this.updateLinksPosition(connectNavNode);
	
}




this.expandBindingsForPoint = function(pointFeature, links_bbn) {
	for (var key in links_bbn) {
		var linkData = links_bbn[key];
		if (linkData["type"] == "link-bbn") {
			var destinationPoint_id = linkData["destNode"];
			var destNodeFeature = navNodes[destinationPoint_id]["nodeFeature"];
			this.selectStartPointAndStartConnection(destNodeFeature, pointFeature.getGeometry().getCoordinates());
			this.createConnectionToPoint(pointFeature);

		} else if (linkData["type"] == "connect-node-bbl") {
			var coord = linkData["coord"];
			var startNode_id = linkData['startNode'];
			var endNode_id = linkData['endNode'];
			
			// get link
			var link = navNodes[startNode_id]["links"][endNode_id];
			if(link){
			this.selectStartLinkPointAndStartConnection (link, coord)
			this.createConnectionToPoint(pointFeature);
			}
		}
	}

}

this.expandBindingsForPolygon = function(polygonFeature, links_bbn) {
	for (var key in links_bbn) {
		var linkData = links_bbn[key];
		if (linkData["type"] == "link-bbn") {
			var destinationPoint_id = linkData["destNode"];
			var destNodeFeature = navNodes[destinationPoint_id]["nodeFeature"];
			this.selectStartPointAndStartConnection(destNodeFeature, polygonFeature.getGeometry().getInteriorPoint().getCoordinates());
			this.createConnectionToPolygon(polygonFeature);

		} else if (linkData["type"] == "connect-node-bbl") {
			var coord = linkData["coord"];
			var startNode_id = linkData['startNode'];
			var endNode_id = linkData['endNode'];
			
			// get link
			var link = navNodes[startNode_id]["links"][endNode_id];
			if(link){
			this.selectStartLinkPointAndStartConnection (link, coord)
			this.createConnectionToPolygon(polygonFeature);
			}
		}
	}

}

	this.isNavNode = function (feature) {
		return feature && feature.get("type") == "nav-node";
	}
	this.isNavPolygon = function (feature) {
		return feature && feature.get("type") == "nav-node-polygon";
	}
	this.isNavLink = function (feature) {
		return feature && feature.get("type") == "nav-link";
	}
	this.isLinkBBN = function (feature) {
		return feature && feature.get("type") == "link-bbn";
	}
	this.isNavLinkConnectNode = function (feature) {
		return feature && feature.get("type") == "nav-node-bbl";
	}

	this.isPoint = function (feature) {
		return feature && feature.get("type") == "Point";
	}
	this.isPolygon = function (feature) {
		return feature && feature.get("type") == "Polygon";
	}
	
	


this.createNavNodeFeature = function (pointData) {
	
	var point = new ol.geom.Point(pointData['coord']);
	var nodeFeature =
		new ol.Feature({
			type : pointData['type'],
			geometry : point,
			name : pointData['label']
		});
    nodeFeature.setId(pointData['id']);
	if(this.isNavLinkConnectNode(nodeFeature))
	nodeFeature.setStyle(this.linkConnectionPointStyleDefault);
	else 
	nodeFeature.setStyle(this.defaultPointStyle);
	this.vector_layer.getSource().addFeature(nodeFeature);
	return nodeFeature;
}

this.createNavNodePolygonFeature = function (polygonData) {

	var polygon = new ol.geom.Polygon(polygonData['coord']);
	var nodeFeature =
		new ol.Feature({
			type : 'nav-node-polygon',
			geometry : polygon,
			name : polygonData['label']
		});
	
    nodeFeature.setId(polygonData['id']);
	nodeFeature.setStyle(this.polygonStyle);
	this.vector_layer.getSource().addFeature(nodeFeature);
	return nodeFeature;
}

this.createNavLinkFeature = function (linkData) {
	
var linkFeature =
		new ol.Feature({
			type : 'nav-link',
			geometry : new ol.geom.LineString(linkData['coord']),
			name : linkData['label']
		});
    linkFeature.setId(linkData['id']);
	linkFeature.setStyle(this.connectionLinkStyle);
	this.vector_layer.getSource().addFeature(linkFeature);
	return linkFeature;
}
	
}	